import time
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.remote.webelement import WebElement
from colorama import init, Fore, Style, Back
import pyodbc
from selenium.webdriver.support import expected_conditions as EC
import sys
from selenium.common.exceptions import TimeoutException
from Navigations import *
from utils import *
from arguments import *

#Comparaison de 2 valeurs => renvoie True ou False
def compare(cond1, operateur, cond2):
    if operateur == "==":
        return cond1 == cond2
    elif operateur == "!=":
        return cond1 != cond2
    elif operateur == ">":
        return cond1 > cond2
    elif operateur == "<":
        return cond1 < cond2
    elif operateur == ">=":
        return cond1 >= cond2
    elif operateur == "<=":
        return cond1 <= cond2      
    elif operateur == "contain":
        return cond2 in cond1
    elif operateur == "startwith":
        return cond1.startswith(cond2)
    elif operateur == "endwith":
        return cond1.endswith(cond2)
    else:
        raise ValueError(f"Opérateur inconnu : {operateur}")

#Gestion des conditions
def execondition(driver, mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile):

    cle = mots[0]

    if cle == "else" or cle == "else:":
        try:
            if len(condition) <= 0:
                raise ValueError("Erreur : Aucune condition précédente pour le bloc 'else'.")
            lastCond = condition[-1]
            if lastCond['find-else'] == False:
                lastCond['find-else'] = True
                verbose(f"Bloc 'else' trouvé")
        except Exception as e:
            erreur(f"❌ Une erreur s'est produite dans le bloc 'else' : {e}")

    elif cle == "endif":
        try:
            if len(condition) <= 0:
                raise ValueError("Erreur : Aucune condition précédente pour le bloc 'endif'.")
            condition.pop()
            ext = False 
            verbose(f"Fin de la condition.")
        except Exception as e:
            erreur(f"❌ Une erreur s'est produite dans le bloc 'endif' : {e}")

    elif len(condition) > 0:
        tmp = condition[-1]
        res = None

        for cond in condition:
            if (cond["value"] == True and cond["find-else"] == False) or (cond["value"] == False and cond["find-else"] == True):
                res = True
            else:
                res = False
                break 

        if tmp["value"] == True and tmp["find-else"] == False and not ext and res:
            ext = True
            verbose("Condition : valide pour l'exécution du 'if'.")
            variables, returnValue = execute(driver, mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)
        
        elif tmp["value"] == False and tmp["find-else"] == True and not ext and res: 
            ext = True
            verbose("Condition : valide pour l'exécution du 'else'.")
            variables, returnValue = execute(driver, mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)

        else:
            verbose("Condition : non-valide pour l'exécution de la commande.")

    return variables,returnValue

#Renvoie le résultat d'une condition
def resCondition(mots):
    operateurs = ["==", "!=", ">", "<", ">=", "<=", "contain", "startwith", "endwith"]
    opt_logique = ["or", "and"]

    try:
        pos_operateur = [i for i, mot in enumerate(mots) if mot in operateurs]
        pos_optLog = [i for i, mot in enumerate(mots) if mot in opt_logique]

        pos_all = [pos_operateur[0]]
        cond = {}
        log = {}
        opera = {}

        if len(pos_operateur) > 1 and len(pos_optLog) > 0:
            n = 0
            for opt in pos_operateur[1:]:
                pos_all.append(pos_optLog[n])
                pos_all.append(opt)
                n += 1

        isCond = 1
        marqueur = 0
        nbcond = 1
        nblog = 1
        nbopera = 1

        for opt in pos_all:
            if isCond == 1 or isCond == 3:
                cond[f"cond{nbcond}"] = convertype(mots[marqueur:opt])  
                nbcond += 1
                marqueur = opt + 1
                isCond += 1
            if isCond == 2:
                opera[f"opera{nbopera}"] = ''.join(mots[opt])  
                isCond += 1
                nbopera += 1
            if isCond == 4:
                log[f"log{nblog}"] = ''.join(mots[opt])  
                isCond = 1
                nblog += 1
            if pos_all[-1]:
                cond[f"cond{nbcond}"] = convertype(mots[opt+1:])  


        expression = ' '.join(map(str, mots))
        verbose(f"Expression complète à évaluer : {expression}")

        cmplt = False
        n = 1
        cond1 = ''
        cond2 = ''
        operateur = ''
        condVer = {}

        for i in range(1, len(cond) + 1):
            if not cmplt:
                cond1 = cond[f"cond{i}"]
                
                if isinstance(cond1, list):
                    cond1 = [str(e) if not isinstance(e, WebElement) else "[WebElement]" for e in cond1]
                    cond1 = ' '.join(cond1)

                operateur = opera[f"opera{n}"]
                cmplt = True
            else:
                cond2 = cond[f"cond{i}"]
                
                if isinstance(cond2, list):
                    cond2 = [str(e) if not isinstance(e, WebElement) else "[WebElement]" for e in cond2]
                    cond2 = ' '.join(cond2)

                operateur = opera[f"opera{n}"]
                comparaison = compare(cond1, operateur, cond2)
                condVer[f"condVer{n}"] = comparaison
                n += 1
                cmplt = False

 
        cndCompo = []
        q = 1
        condLog = False
        for i in range (1, len(condVer) * 2):
            if not condLog:

                cndCompo.append(condVer[f"condVer{q}"])
                condLog = True
            else:
                cndCompo.append(log[f"log{q}"])
                q += 1
                condLog = False

        i = 0
        while i < len(cndCompo): 
            if cndCompo[i] == "and":
                cond1 = cndCompo[i - 1]
                cond2 = cndCompo[i + 1]
                res = cond1 and cond2
                cndCompo[i - 1:i + 2] = [res] 
            else:
                i += 1

        i = 0
        while i < len(cndCompo): 
            if cndCompo[i] == "or": 
                cond1 = cndCompo[i - 1]
                operateur = cndCompo[i]
                cond2 = cndCompo[i + 1]
                res = cond1 or cond2
                cndCompo[i - 1:i + 2] = [res]  
            else:
                i += 1 
        verbose(f"Résultat de la condition : {cndCompo[0]}")
        return cndCompo[0]
    
    except Exception as e:
        verboseRed(f"❌ Erreur dans la gestion de la condition 'if' : {e}")
        raise e

#Fonction principales qui exécute les commandes
def execute(driver, mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile):

    cle = mots[0]
    #Renvoie la longueur d'une variable
    if any(isinstance(mot, str) and mot.startswith('len.') for mot in mots):

        for mot in mots:
            if isinstance(mot, str) and mot.startswith('len.'):
                pos_len = mots.index(mot)  
                len_variable = mot 
                var = len_variable.split('.', 1)

                try:
                    if len(var) > 1:
                        var_name = var[1]
                    else:
                        raise ValueError(f"Commande mal formée, variable manquant après 'len.' dans la commande {mots}")

                    if var_name[1:] not in variables:
                        raise ValueError(f"Variable '{var_name}' non trouvée dans les variables.")
                    
                    var_value = variables[var_name[1:]]

                    if isinstance(var_value, (list, dict, str)):
                        lng = len(var_value)
                        
                    else:
                        raise TypeError(f"La variable '{var_name}' n'est pas mesurable pour la longueur.")
                    
                    nouv_mots = mots[:pos_len] + [str(lng)] + mots[pos_len+1:]
                    nouv_mots = convertype(nouv_mots)
                    verbose(f"Nouvelle commande : {nouv_mots}")
                    verboseWhite('-' * 25)
                    verboseWhite(f"Execution de la commande : {nouv_mots}")
                    
                    variables, returnValue = execute(driver, nouv_mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)

                except Exception as e:
                    verboseRed(f"Erreur lors du calcul de la longueur : {e}")
                    raise e 

    #renvoie "continue"
    elif cle == "continue":
        verbose("Continue")
        return "continue"
    
    #Renvoie "break"
    elif cle == "break":
        verbose("Break")
        return "break"

    #Prend le résultat d'une comparaison et l'ajoute dans le dictionnaire condition sous la forme de : {"value" : résultat, "find-else : False"}
    elif cle == "if":
        res = resCondition(mots[1:])
        condition.append({"value": res, "find-else": False})
       
    #Exécute execondition si le dictionnaire condition n'est pas vide et que la variable ext est à False
    elif len(condition) > 0 and not ext:
        variables, returnValue = execondition(driver, mots, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)

    #Affiche un message (exécutée même sans l'argument -v)
    elif cle == "print":
        valeurs_affichees = ' '.join(str(mot) for mot in mots[1:])   
        print(Fore.CYAN + f"print : {valeurs_affichees}")
    
    #Affiche le texte qu'il y a dans un WebElement ou WebDriver
    elif cle == "printext":
        verbose(f"print text : {mots[1].text}")

    #Incrémente une variable de 1
    elif len(mots) >= 3 and mots[1] == '+=':
        try:
            if mots[0] not in variables:
                raise ValueError(f"Variable '{mots[0]}' non définie.")
            add1 = int(variables[mots[0]])
            add2 = int(mots[2])
            res = add1 + add2
            variables[mots[0]] = res  
            verbose(f"{add1} += {add2} = {res}")
        
        except Exception as e:
            erreur(f"❌ Erreur lors de l'opération += : {e}")

    #Exécute affectation s'il y a quelque chose a affecter dans une variable
    elif len(mots) > 2 and  isinstance(mots[0],str) and mots[1] == "=":
        variables = affectation(config, variables, driver, mots, modules)

    #Charge la page correspondant à l'url
    elif cle == "url":

        verbose("")
        verboseGreen(f"URL à charger : {mots[1]}")
            
        driver.get(mots[1])
        if args.verbose:
            verboseGreen(f"Page chargée : {mots[1]}")
            verbose(f"")

    #Clique sur un élément en fonction du chemin indiqué
    elif cle == "click":
        click(driver,mots)        
    
    #Efface le contenu et écrit dans un élément en fonction du chemin indiqué
    elif cle == "CWrite":
        CWrite(driver,mots)
    
    #Ecrit dans un élément en fonction du chemin indiqué
    elif cle == "write":
        write(driver,mots)

    #Clique puis écrit sur un élément
    elif cle == "clickWrite":
        sous_mots = ["click"]
        for mot in mots[1:]:
            sous_mots.append(mot)
        verbose(f"Fonctions click : {sous_mots}")
        click(driver,sous_mots)
        sous_mots = ["write"]
        for mot in mots[1:]:
            sous_mots.append(mot)
        verbose(f"Fonction write : {sous_mots}")
        write(driver, sous_mots)

    #Clique, écrit puis appuie sur Entrée
    elif cle == "clickWriteEnter":
        sous_mots = ["click"]
        for mot in mots[1:]:
            sous_mots.append(mot)
        verbose(f"Fonctions click : {sous_mots}")
        click(driver,sous_mots)
        sous_mots = ["write"]
        for mot in mots[3:]:
            sous_mots.append(mot)
        verbose(f"Fonction write : {sous_mots}")
        writeEnter(driver, sous_mots)

    #Attend le temps indiqué
    elif cle == "sleep":
        delay = int(mots[1])
        verbose(f"Attente : {delay} secondes...")
        time.sleep(delay)
        verbose(f"Attente : terminée.")

    #Exécute une requête SQL 
    elif cle == "check":
        try:
            conn = pyodbc.connect('Driver={SQL Server};Server=localhost\\SQLExpress;Database=ZF;Trusted_Connection=True;')
            
            cursor = conn.cursor()

            if all(kw in mots for kw in ["check", "if", "from", "exist", "in"]):
                pos_if = mots.index("if")
                pos_not = mots.index("not") if "not" in mots else None
                pos_exist = mots.index("exist")
                pos_in = mots.index("in")
                pos_from = mots.index("from")
                pos_where = mots.index("where") if "where" in mots else None

                nom = " ".join(mots[pos_if + 1:pos_not if pos_not else pos_exist]).strip()
                champ = " ".join(mots[pos_in + 1:pos_from]).strip()
                table = " ".join(mots[pos_from + 1:pos_where]).strip() if pos_where else " ".join(mots[pos_from + 1:]).strip()
                condition = " ".join(mots[pos_where + 1:]).strip() if pos_where else ""

                if condition:
                    query = f"SELECT {champ} FROM {table} WHERE {condition}"
                else:
                    query = f"SELECT {champ} FROM {table}"

                
                print(Fore.RESET)

                verboseBlue(f"Exécution de la requête : {query}")

                cursor.execute(query)
                rows = cursor.fetchall()

                verboseBlue(f"Données récupérées : {[row[0] for row in rows]}")

                if any(nom.lower() == str(row[0]).strip().lower() for row in rows):
                    verboseBlue(f"{nom} est présent dans les données")
                    if "not" in mots:
                        driver.close()
                        if args.erreur:
                            erreur("Le programme s'arrête car les données sont présentes. Le navigateur est fermé.")
                        sys.exit()
                else:
                    erreur("Aucune donnée trouvée.")
                    if "not" not in mots:
                        driver.close()
                        erreur("Le programme s'arrête car aucune donnée n'est présente. Le navigateur est fermé.")
                        sys.exit()
            else:
                if args.erreur:
                    erreur("Erreur : Commande 'check if ... exist in ... where ...' mal formulée.")
                sys.exit()

        except pyodbc.Error as e:
            if args.erreur:
                erreur(f"Erreur SQL : {e}")
                sys.exit()
        except Exception as e:
            if args.erreur:
                erreur(f"Erreur lors de l'exécution de la commande : {e}")
            sys.exit()
        finally:
            cursor.close()
            conn.close()
        print(Fore.RESET)

    #Trouve un élément sur la page en indiquant le texte contenu et l'action a réaliser
    elif cle == "find":

        actions = ["click", "write", "clickWrite", "clickWriteEnter"]

        pos_action = next((i for i, mot in enumerate(mots) if mot in actions), None)

        if pos_action is None:
            raise ValueError("Aucune action valide ('click', 'write', 'clickWrite') trouvée.")

        if mots[1] == "wait":
            wait_time = int(mots[2]) if mots[2].isdigit() else 10  
            element_type = mots[3]
            identifier = mots[4:pos_action]
            string = mots[pos_action + 1:]
        else:
            wait_time = None
            element_type = mots[1]
            identifier = mots[2:pos_action]
            string = mots[pos_action + 1:]

        element = find_element_by_type(driver, mots, element_type, identifier)
        if not element:
            raise RuntimeError(f"Élément non trouvé : type='{element_type}', identifiant='{identifier}'")

        verbose(f"Élément trouvé : {element}")

        if wait_time:
            try:
                WebDriverWait(driver, wait_time).until(EC.visibility_of(element))
                WebDriverWait(driver, wait_time).until(EC.element_to_be_clickable(element))
            except TimeoutException:
                raise RuntimeError(
                    f"L'élément de type '{element_type}' avec identifiant '{' '.join(identifier)}' "
                    f"n'a pas été trouvé dans le délai imparti ({wait_time} secondes)."
                )

        if not (element.is_enabled() and element.is_displayed()):
            raise RuntimeError(f"L'élément de type '{element_type}' avec identifiant '{identifier}' n'est pas interactif.")

        action = mots[pos_action]
        try:
            if action == "click":
                element.click()
                verbose("Action 'click' effectuée.")
            elif action == "write":
                element.clear()
                element.send_keys(' '.join(string))
                verbose(f"Texte écrit : {' '.join(string)}")
            elif action == "clickWrite":
                element.click()
                time.sleep(2)
                element.clear()
                element.send_keys(' '.join(string))
                verbose(f"Action 'click' suivie de l'écriture : {' '.join(string)}")
            elif action == "clickWriteEnter":
                element.click()
                time.sleep(2)
                element.clear()
                element.send_keys(' '.join(string))
                time.sleep(2)
                element.send_keys(Keys.ENTER)
                verbose(f"Action 'click' suivie de l'écriture : {' '.join(string)}")

        except Exception as e:
            raise RuntimeError(f"Erreur lors de l'exécution de l'action '{action}' : {e}")

    #Rafraichi la page   
    elif cle == "refresh":
        driver.refresh()

    #Exécute une méthode dans une classe
    elif cle == "method":
            
        classe = mots[1]
        method = mots[2] 
        param = mots[3:]

        try:
            if not hasattr(classe, method):
                print(Fore.RED + f"Erreur : La méthode '{method}' n'existe pas dans la classe '{classe.__class__.__name__}'.")
                sys.exit()

            verbose(f"Exécution de la méthode : {method} avec les paramètres : {param}")

            method_to_call = getattr(classe, method)
            result = method_to_call(*param)

            print(Fore.CYAN + f"Résultat : {result}")

        except TypeError as te:
            erreur(f"TypeError lors de l'exécution de {method} : {te}")
            raise te
        except Exception as e:
            erreur(f"Erreur inattendue lors de l'exécution de {method} : {e}")
            raise e

    #Renvoie la variable comme résultat du programme
    elif cle == "return":
        verbose(f"Retour avec la valeur : {mots[1]}")  
        returnValue = mots[1]

    #Permet de naviguer entres les frames
    elif cle == "switch" and mots[1] == "frame" :
        try:
            frm = mots[2]
            driver.switch_to.frame(frm)
            verbose(f"Changement réussi vers la frame : {frm}")
        except IndexError:
            erreur("Aucun nom de frame fournie.")
        except Exception as e:
            erreur(f"Impossible de changer de frame : {e}")

    #Permet de revenir à la frame parent
    elif cle == "parent" and mots[1] == "frame":
        try:
            driver.switch_to.parent_frame()
            verbose("Changement réussi vers la frame parent.")
        except Exception as e:
            erreur(f"Impossible de revenir à la frame parent : {e}")

    #Exécute une boucle for
    elif cle == "loop":
        elements = mots[3]  
        newId = mots[4]     
        row = mots[1] 

        verboseBlue(f"Exécution de la boucle : {row} in {elements}")
        verboseWhite('-' * 25)

        if not isinstance(newId, list) or not newId:
            erreur("⚠ Attention : Aucune instruction à exécuter dans la boucle.")
            return variables, returnValue

        if 'range' in elements:

            nb = elements[1]
            if nb.startswith('$'):
                nb = nb[1:]
                nb = variables[nb]
            nb = int(nb)
            
            n = 0
            cmd_break = False

            for i in range(int(nb/len(row))):

                if cmd_break:
                    break
                   
                for var in row:
                    if n < nb:
                        variables[var] = n
                        verboseMagenta(f"{var} = {variables[var]}")
                        n += 1
                        
                skip_commands = False

                for ins in newId:

                    if cmd_break:
                        break
                    if skip_commands:
                        break  

                    verboseWhite('-' * 25)
                    if skip_commands:
                        break  

                    verboseWhite(f"Exécution de la commande : {ins}")
                    instruction = ins.copy()
                    insVar = isVariable(instruction, variables)
                    insVar = convertype(insVar)

                    result = execute(driver, insVar, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)

                    if "continue" in result:
                        verbose("Commande 'continue' détectée.")

                        if len(condition) > 0:
                            tmp = condition[-1]
                            if (tmp["value"] == True and tmp["find-else"] == False) or (tmp["value"] == False and tmp["find-else"] == True):
                                verbose("Condition valide pour le 'continue'.")
                                verboseWhite("Passage à l'itération suivante.")  
                                verboseWhite('-' * 25)
                                skip_commands = True
                                condition.pop()
                                break
                            else:
                                verbose("Condition non-valide pour le 'continue'.")
                        else:
                            verboseWhite("Passage à l'itération suivante.")  
                            skip_commands = True
                            break

                    if 'break' in result:
                        verbose("Commande 'break' détectée.")

                        if len(condition) > 0:
                            tmp = condition[-1]
                            if (tmp["value"] == True and tmp["find-else"] == False) or (tmp["value"] == False and tmp["find-else"] == True):
                                verbose("Condition valide pour le 'break'.")
                                verboseWhite('-' * 25)
                                cmd_break = True
                                condition.pop()
                                break
                            else:
                                verbose("Condition non-valide pour le 'break'.")
                        else:
                            cmd_break = True
                            break


                    verboseWhite(f"Commande exécutée")
                verboseWhite('-' * 25)

        else:

            elements = elements[0]
            elements = variables[elements[1:]]

            if elements is None or not isinstance(elements, list):
                erreur(f"⚠ Erreur : La variable '{elements}' n'est pas une liste valide.")
                return variables, returnValue

            n = 0
            cmd_break = False

            for i in range(0,int(len(elements)/len(row))):
                
                if cmd_break:
                    break

                for var in row:
                    if n < len(elements):
                        variables[var] = elements[n]
                        verboseMagenta(f"{var} = {variables[var]}")
                        n += 1

                skip_commands = False  

                for ins in newId:
                    verboseWhite('-' * 25)
                    if skip_commands:
                        break  
                    if cmd_break:
                        break

                    verboseWhite(f"Exécution de la commande : {ins}")
                    instruction = ins.copy()
                    insVar = isVariable(instruction, variables)
                    insVar = convertype(insVar)

                    result = execute(driver, insVar, modules, variables, config, condition, ext, liste, row, newID,returnValue, exeWhile)


                    if "continue" in result:
                        verbose("Commande 'continue' détectée.")

                        if len(condition) > 0:
                            tmp = condition[-1]
                            if (tmp["value"] == True and tmp["find-else"] == False) or (tmp["value"] == False and tmp["find-else"] == True):
                                verbose("Condition valide pour le 'continue'.")
                                verboseWhite("Passage à l'itération suivante.")  
                                verboseWhite('-' * 25)
                                skip_commands = True
                                condition.pop()
                                break
                            else:
                                verbose("Condition non-valide pour le 'continue'.")
                        else:
                            verboseWhite("Passage à l'itération suivante.")  
                            skip_commands = True
                            break

                    if 'break' in result:
                        verbose("Commande 'break' détectée.")

                        if len(condition) > 0:
                            tmp = condition[-1]
                            if (tmp["value"] == True and tmp["find-else"] == False) or (tmp["value"] == False and tmp["find-else"] == True):
                                verbose("Condition valide pour le 'break'.")
                                verboseWhite('-' * 25)
                                cmd_break = True
                                condition.pop()
                                break
                            else:
                                verbose("Condition non-valide pour le 'break'.")
                        else:
                            cmd_break = True
                            break


                    verboseWhite(f"Commande exécutée")

                if not skip_commands:  
                    verboseWhite('-' * 25)

        verboseBlue("Fin de la boucle")

    #Permet d'exécuter un script JavaScript dans le conetexte de la page chargée
    elif cle == "execute_script" in mots:
        script = mots[1]
        try:
            driver.execute_script(script)
            verbose(f"Script exécuté : {script}")
        except Exception as e:
            erreur(f"Erreur lors de l'exécution du script : {e}")

    #Permet d'ajouter une nouvelles valeur dans une liste ou un dictionnaire
    elif 'append' in mots:
        try:
            variable = mots[0]  
            element = mots[2]   

            if "[" in variable and "]" in variable:
                base_var, key = variable.split("[", 1)
                key = key.rstrip("]")

                if key.startswith('$'):
                    key = variables[key[1:]] 

                if base_var in variables and isinstance(variables[base_var], dict):
                    variables[base_var][key] = element
                    verbose(f"Valeur '{element}' ajoutée dans {base_var}[{key}]")
                else:
                    erreur(f"❌ Erreur : '{base_var}' n'est pas un dictionnaire ou n'existe pas.")

            elif variable in variables and isinstance(variables[variable], list):
                variables[variable].append(element)
                verbose(f"Valeur '{element}' ajoutée à la liste {variable}.")
            
            else:
                erreur(f"❌ Erreur : La variable '{variable}' n'est ni une liste ni un dictionnaire.")

        except Exception as e:
            verboseRed(f"❌ Erreur lors de l'exécution de 'append' : {e}")
            raise e

    #Permet de basculer d'une fenêtre à une autre 
    elif 'switch_window' in mots:
        try:
            indx = int(mots[1])  
            if 0 <= indx < len(driver.window_handles):
                driver.switch_to.window(driver.window_handles[indx])
                verbose(f"Fenêtre basculée vers l'index {indx}.")
            else:
                erreur(f"❌ Erreur : L'index {indx} est hors de portée. Il n'y a que {len(driver.window_handles)} fenêtre(s) ouverte(s).")
        except ValueError:
            erreur(f"❌ Erreur : '{mots[1]}' n'est pas un index valide.")
        except Exception as e:
            erreur(f"❌ Erreur inattendue lors du basculement de fenêtre : {e}")

    #Permet d'exécuter une boucle while
    elif 'while' in mots:
        cond = mots[1]
        cmds = mots[3]
        
        verboseBlue(f"Début d'une boucle while avec la condition : {cond}")

        

        while True:
            verboseWhite('-' * 25)
            cond_evaluated = isVariable(cond, variables)  
            cond_evaluated = convertype(cond_evaluated) 
            verboseMagenta(f"Condition évaluée : {cond_evaluated}")
            if not resCondition(cond_evaluated):
                break
            
            for commande in cmds:
                verboseWhite('-' * 25)
                verboseWhite(f"Execution de la commande : {commande}")
                commande = isVariable(commande,variables)
                execute(driver, commande, modules, variables, config, condition, ext, liste, row, newID, returnValue, exeWhile)
                verboseWhite(f"Commande exécutée")
        
        verboseBlue("Fin de la boucle while.")

    #Permet d'exécuter un bloc try-except
    elif 'try' in mots:
        cmdTry = mots[1]
        cmdExcept = mots[3]

        try:
            for cmd in cmdTry:
                verboseWhite(f"Execution de la commande : {cmd}")
                commande = isVariable(cmd,variables)
                execute(driver, cmd, modules, variables, config, condition, ext, liste, row, newID, returnValue, exeWhile)
        except:
            for cmd in cmdExcept:
                verboseWhite(f"Execution de la commande : {cmd}")
                commande = isVariable(cmd,variables)
                execute(driver, cmd, modules, variables, config, condition, ext, liste, row, newID, returnValue, exeWhile)

    else:
        verboseRed("Commande non-trouvée")


    return variables, returnValue